% Hybrid Lidar Data Reader
%
% Data saved from Hybrid Lidar system with Kinect. Colour and  depth have
% been cropped to the illumination region.
%
% Files contain:
% col: Colour image with all three channels (421x421x3), green channel in (:,:,2).
% dep: Depth image (141x141), value is depth in milimeters, converted to meters in figure.
% lidarData: Lidar data from flood illumiation (line 1 distance, line 2 signal).
%
%Steven Johnson, UoGlagsow October 2020
%Catherine Higham, UoGlasgow January 2024

path = 'Transfer1019/';
fileList = dir([path '*.mat']);

Nxy=128;
for i=1:numel(fileList)
load(fileList(i).name);

denoisedD = fill_depth_colorization(double(col)/255, double(dep), 1);
imdb.depth(:,:,i)=double(denoisedD)/1000;
imdb.image(:,:,:,i)=double(col);

imdb.lidar(:,:,i)=double(lidarData)';
end


