%% Code to reproduce Figure 7 in the paper
% Catherine Higham, UoGlasgow January 2024
% Higham, C. F., Johnson, S., Radwell, N., Padgett, M. J. and Murray-Smith, R.(2023)
% Efficient Bayesian deep inversion for depth prediction. Journal of Computational Dynamics, 

%% data

clear all
load('Results/imdb240103.mat')
load('Results/rgbpred.mat')


%% plot

N=128;
crop=2;
Nc=N-2*crop;
[xq, yq] = meshgrid(1:Nc,1:Nc);

idxl=[9 10 11 16];
rl=5;
cl=length(idxl);
figure(10), clf(10)
for j=1:length(idxl)
    idx=idxl(j);
    sidx=j;
    ct=0;
subplot(rl,cl,sidx+cl*ct)
imagesc(imdb.image(:,:,:,idx)/255)
axis off
title('RGB image')

ct=ct+1;
subplot(rl,cl,sidx+cl*ct)
plot(imdb.edgesl,imdb.yci2(:,idx),'g')
hold on
plot(imdb.edgesl,imdb.syi2(:,idx),'r','LineWidth',2)
%legend('\it lidar','\it smooth')
ylim([-0.2 1])
xlim([0 5])
if j==1
ylabel('standardised intensity')
xlabel('depth (m)')
title('lidar(g)/smooth(r)')
end

ct=ct+1;
subplot(rl,cl,sidx+cl*ct)
vref=predictions(:,:,idx)/10;
figsetup1v4
title(strcat('RGBonly (psnr=',num2str(pni(idx),'%2.1f'),')'))
az = 0;
el = 90;
view(az, el);
if j==1
xlabel('depth (m)')
ylabel('top view')
end

ct=ct+1;
subplot(rl,cl,sidx+cl*ct)
vref=imdb.R(:,:,1,idx)/10;
figsetup1v4
title(strcat('GLL (psnr=',num2str(imdb.pi(idx),'%2.1f'),')'))
az = 0;
el = 90;
view(az, el);
if j==1
xlabel('depth (m)')
ylabel('top view')
end

ct=ct+1;
subplot(rl,cl,sidx+cl*ct)
vref=imdb.depth(:,:,idx)/10;
figsetup1v4
title('Kinect')
az = 0;
el = 90;
view(az, el);
if j==1
xlabel('depth (m)')
ylabel('top view')
end
end
