function sy = decon(yc,ImpRes,smoothWidth)
% decon(yc,ImpRes,smoothWidth)
% Function to deconvolve signals from LIDAR using a Impulse response
% function, this will de convolve and smooth the data.
% INPUTS
% yc: Input signal
% ImpRes: Impulse response function (must be same length as yc)
% smoothWidth: Vale to determine smoothing width over point.
% OUTPUTS
% sy: Output smoothed and deconvolved signal
%
% Steven Johnson, UofGlasgow October 2020

if smoothWidth < 0.5
     smoothWidth = 0.5;
end

ydc=ifft(fft(yc)./fft(ImpRes)).*sum(ImpRes);  % Deconvolution by fft/ifft
sy=fastsmooth(ydc,smoothWidth,3); % Smooth the result with SmoothWidth
sy=fastsmooth(sy,smoothWidth,3);  % Smooth again
